/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var forEach = require('./forEach');
var nested = require('./nested');
var util = require('./util');

var lastTreeIndent;
var indent = {
	lastTreeIndent: 0,

	setIndent: function(val){
		this.lastTreeIndent = val;
	},

	sub: function(){
		this.lastTreeIndent --;
	},

	getStr: function(isForLog){
		var level = this.lastTreeIndent + 1 + (isForLog ? 1 : 0);
		var indentStr = util.repeat(' ', (level - 1) * 4);
		var prefix = ('  ' + level).substr(-2) + '|';
		var str = prefix + indentStr;

		return isForLog ? str : forEach.insertSerialNo(str);
	},

	backup: function(){
		lastTreeIndent = this.lastTreeIndent;
	},

	restore: function(){
		this.lastTreeIndent = lastTreeIndent;
	},

	reset: function(){
		this.lastTreeIndent = 0;
	}
};

module.exports.__proto__ = indent;
