/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var logArray = require('./logArray');

var util = {
	log: function(){
		var args = Array.prototype.slice.call(arguments);

		/* istanbul ignore else */
		if (logArray.isSaveToArr) {
			logArray.save(args[0] + ' ' + args[1]);
		}
		else {
			var g = typeof global === 'object' ? global : typeof window === 'object' ? window : {};
			!g.isDisabledLog && console.log.apply(console, args);
		}
	},

	repeat: function (str, times) {
		return new Array(times + 1).join(str);
	}
};

module.exports.__proto__ = util;
