/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('../tas');
var log = require('../log');
var tester = require('../tester');
var expect = require('chai').expect;

var config = require('../config');

describe('3.as promise: tas.resolve()', function(){
	it('should return ,1', function(done){

		this.timeout(config.netTimeout);

		var test = function(done, count){
			var a = 0;

			tas.begin();

			tas.promise(function (){
				setTimeout(function(err, data){
					if (count === 1) {
						a ++;
					}
					tas.resolve(data);
				}, 0)
			});

			tas(function (data){
				a ++;
			});

			tas(function (){
				done(count, a);
			});
		};

		var check = function(results){
			log(results.toString());
			expect(results.toString() === '2,1').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
