/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('../tas');
var log = require('../log');
var tester = require('../tester');
var expect = require('chai').expect;

describe('4.forEach tasks: tas.continue()', function(){
	it('should return 3,5', function(done){

		var test = function(done, count){
			var a = 0;

			tas.begin();

			tas(function(){
				var arr = [1, 2];
				return [arr];
			});

			// Perform a set of tasks for each array element
			tas.forEach({
				init: function(element){
					a += element;
				},

				check: function(){
					if (count === 1) {

						[1, 2, 3].forEach(function(){

							// Ignore the remaining tasks, and go to init() for next loop.
							tas.continue();
						});
					}
				},

				calc: function(){ // ignored when flag === 0
					a ++;
				}
			});

			tas(function (){
				done(count, a);
			});
		};

		var check = function(results){
			log(results.toString());
			expect(results.toString() === '3,5').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
