/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('../tas');
var log = require('../log');
var tester = require('../tester');
var expect = require('chai').expect;

var config = require('../config');

describe('4.forEach tasks: tas.forEach()', function(){
	it('should return 9,7', function(done){

		this.timeout(config.netTimeout);

		var test = function(done, count){
			var a = 0;

			tas.begin();

			tas(function () {
				var arr = [1, 2];
				return [arr];
			});

			// Perform a set of tasks for each array element.
			tas.forEach({
				init: function(element, index){
					a ++; // 2 times
				},

				async: function(){
					setTimeout(function timeout1(){
						tas.next();
					}, 0);

					return "await";
				},

				calc: function(){
					if (count === 1) {
						a ++; // 2 times
					}
				},

				async2: function(){
					setTimeout(function timeout2(){
						a ++; // 2 times
						tas.next();
					}, 0);

					return "await";
				},

				calc2: function(){
					a ++; // 2 times
				}
			});

			tas(function calcMore(){
				a ++; // 9
			});

			tas(function end(){
				done(count, a);
			});
		};

		var check = function(results){
			log(results.toString());
			expect(results.toString() === '9,7').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
