/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('../tas');
var log = require('../log');
var tester = require('../tester');
var expect = require('chai').expect;

var config = require('../config');

describe('5.break the flow: abort in tas.forEach()', function(){
	it('should return ,5', function(done){

		this.timeout(config.netTimeout);

		var test = function(done, count){
			var a = 0;

			tas.begin();

			tas.await(function () {
				setTimeout(function(){
					var arr = [1, 2];
					tas.next(arr);
				}, 0);
			});

			tas.forEach({
				init: function init(element, index){
					a ++; // 2 times
				},

				async: function async(){
					setTimeout(function timeout1(){
						tas.next();
					}, 0);
					return "await";
				},

				calc: function calc(){
					if (count === 1) {

						// Abort Tas, then the remaining tasks will be ignored.
						// So the value of a will be returned only once (when count is 2).
						tas.abort();
					}
					else {
						a ++;
					}
				}
			});

			tas(function(){ // ignored when count === 1
				a ++; // 5
			});

			tas(function (){
				done(count, a); // ignored when count === 1
			});
		};

		var check = function(results){
			log(results.toString());
			expect(results.toString() === ',5').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
