/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('../tas');
var log = require('../log');
var tester = require('../tester');
var expect = require('chai').expect;

describe('5.break the flow: return "break"', function(){
	it('should return 0,1', function(done){

		var test = function(done, count){
			var a = 0;

			tas.begin();

			tas({
				t1: function (){
					if (count === 1) {

						// The remaining task(s) in the current tasks will be ignored.
						return 'break';
					}
				},

				t2: function (){ // ignored
					a ++;
				}
			});

			tas(function (){
				done(count, a);
			});
		};

		var check = function(results){
			log(results.toString());
			expect(results.toString() === '0,1').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
