/**
 * Test of Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */

var tas = require('../tas');
var log = require('../log');
var tester = require('../tester');
var expect = require('chai').expect;

describe('5.break the flow: tas.abort()', function(){
	it('should return ,1', function(done){

		var test = function(done, count){
			var a = 0;

			tas.begin();

			tas({
				t1: function (){
					[1].forEach(function(){
						if (count === 1) {

							// Abort Tas, then the remaining tasks will be ignored.
							// So the value of a will be returned only once (when count is 2).
							tas.abort();
						}
					});
				},

				t2: function (){ // ignored when count === 1
					a ++;
				}
			});

			tas(function (){ // ignored when count === 1
				done(count, a);
			});
		};

		var check = function(results){
			log(results.toString());
			expect(results.toString() === ',1').to.be.equal(true);
			done();
		};

		// Run the test twice
		tester.do(test, check, 2);
	});
});
