(function(r,f){if(typeof define==='function'&&define.amd){define(function(){return f(r,r.document)})}else if(typeof exports==='object'){module.exports=r.document?f(r,r.document):function(w){return f(w,w.document)}}else{r.tas=f(r,r.document)}}(typeof window!=='undefined'?window:this,function(window,document){return (function(modules) { // webpackBootstrap
	// The module cache
	var installedModules = {};

	// The require function
	function __webpack_require__(moduleId) {

		// Check if module is in cache
		if(installedModules[moduleId])
			return installedModules[moduleId].exports;

		// Create a new module (and put it into the cache)
		var module = installedModules[moduleId] = {
			exports: {},
			id: moduleId,
			loaded: false
		};

		// Execute the module function
		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

		// Flag the module as loaded
		module.loaded = true;

		// Return the exports of the module
		return module.exports;
	}

	// expose the modules object (__webpack_modules__)
	__webpack_require__.m = modules;

	// expose the module cache
	__webpack_require__.c = installedModules;

	// __webpack_public_path__
	__webpack_require__.p = "";

	// Load entry module and return exports
	return __webpack_require__(0);
})

/*----------------------------------------------------------------------*/
/**
 * Tas.js
 * (c) 2017 Owen Luke
 * https://github.com/tasjs/tas
 * Released under the MIT License.
 */
/*----------------------------------------------------------------------*/

([

(function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(1);
}),

(function(module, exports, __webpack_require__) {

	var runner = __webpack_require__(2);
	var tasks = __webpack_require__(4);
	var units = __webpack_require__(5);
	var pass = __webpack_require__(7);
	var flag = __webpack_require__(6);
	var abort = __webpack_require__(8);
	var break_ = __webpack_require__(15);
	var begin = __webpack_require__(16);

	var initCore = function(Tas){
		runner.init(Tas);
		units.init(Tas);
	};

	var loadExtensions = function(Tas){
		__webpack_require__(9).init(Tas);
		__webpack_require__(17).init(Tas);
	};

	var Tas = function(obj){
		if (begin.is()) {
			begin.do(obj);
		}
		else if (flag.isAbort()){
			return;
		}

		tasks.add(obj);
	};

	Tas.await = function(obj){
		begin.is() && begin.do(obj);

		obj.isAwait = true;
		tasks.add(obj);
	};

	Tas.promise = function(func){
		Tas.await(func);
	};

	Tas.next = function(a0, a1){
		var len = arguments.length;

		len === 2 ? pass.save2(a0, a1) :
			len === 1 ? pass.save1(arguments[0]) :
				len === 0 ? pass.save0() :
					pass.saveArray(Array.prototype.slice.call(arguments));

		runner.next();
	};

	Tas.resolve = function(err, data){
		pass.save2(err, data);
		runner.next();
	};

	Tas.break = function(){
		break_.do();
	};

	Tas.abort = function(msg){
		abort.do(msg);
	};

	Tas.begin = function(){
		begin.set();
	};

	initCore(Tas);
	loadExtensions(Tas);

	module.exports = Tas;
}),

(function(module, exports, __webpack_require__) {

	var data = __webpack_require__(3);
	var tasks = __webpack_require__(4);
	var units = __webpack_require__(5);
	var pass = __webpack_require__(7);
	var flag = __webpack_require__(6);
	var abort = __webpack_require__(8);
	var break_ = __webpack_require__(15);

	var Tas;
	var forEach;

	var runner = {
		init: function(Tas_){
			Tas = Tas_;
		},

		exec: function(queue){
			var f = data.flag;

			/* istanbul ignore next */
			if (f.isAwait) return;

			var func;
			var result;
			var run = runner.runFunc;

			while(func = queue.shift()) {
				result = run(func);

				if (f.isAwait) {
					break;
				}

				// if not is abort, then set isAwait
				if (runner.setIsAwaitAsTrueIfNeeded(result, func)) {
					break;
				}
			}
		},

		execFunc: function(func){
			var f = data.flag;

			/* istanbul ignore next */
			if (f.isAwait) return;

			var result = runner.runFunc(func);
			runner.setIsAwaitAsTrueIfNeeded(result, func);
		},

		setIsAwaitAsTrueIfNeeded: function(result, func){
			var f = data.flag;
			
			if (result === 'await' || func.isAwait === true) {
				f.isAwait = true;
				return true;
			}
		},

		runFunc: function(func){
			var f = data.flag;

			var isTreeEnabled = data.extensions.isTreeEnabled;
			var isInForEach = data.extensions.isInForEach;
			var isTheLastFunc = func.isTheLastFunc;

			if (isTreeEnabled) {
				Tas.tree.print(func, data.pass.isHasArgs ? data.pass : null);
				if (func.__isIgnore) return func();
			}

			data.maxLayer = data.layer;
			data.layer ++;

			var args = data.pass;
			var result = args.isHasArgs ? func.apply(null, args) : func();

			if (isInForEach && isTheLastFunc && func.root.isForEach) {
				forEach.loop();
			}
			else {
				result === undefined ? pass.save0() :
					Array.isArray(result) ? pass.save(result) :
						result === 'break' ? break_.do() :
							result === 'abort' ? abort.do() :
								result === 'continue' ? forEach.continue() :
									result === 'breakForEach' ? forEach.breakForEach() :
										pass.save1(result);
			}

			data.layer > 0 && data.layer --;
			return result;
		},

		next: function(){
			var d = data;
			var f = d.flag;

			var task;
			var lay = d.maxLayer;
			var arrTasks;

			f.isAwait = false;
			while(lay >= 0) {
				d.layer = lay;

				// Handle the remain functions
				d.units[lay] && d.units[lay].length && runner.exec(d.units[lay]);

				// Handle the tasks in sequence
				arrTasks = d.tasks[lay];

				// If use tas.next() instead of return in tas(), the arrTasks will be undefined.
				/* istanbul ignore else */
				if (typeof arrTasks !== 'undefined') {

					while (!f.isAwait && (task = arrTasks.shift())) {
						f.isAwait = false;

						if (typeof task === 'function') {
							runner.execFunc(task);
						}
						else
						if (task.isForEach === true) {
							forEach.exec(task);
						}
						else {
							units.do(task);
						}
					}
				}

				lay --;
			}

			// When all tasks done, then restore flag isAwait to false
			if (d.tasks[0] && !d.tasks[0].length) {
				f.isAwait = false;
			}
		},

		saveForEach: function(forEach_){
			forEach = forEach_;
		}
	};

	module.exports.__proto__ = runner;
}),

(function(module, exports) {

	var data = {
		layer: 0,
		maxLayer: 0,

		tasks: {},
		units: {},
		pass: [],

		flag: {
			isAwait: false,
			isAbort: false
		},

		extensions: {
			isTreeEnabled: false,
			isInForEach: false
		}
	};

	module.exports = data;
}),

(function(module, exports, __webpack_require__) {

	var data = __webpack_require__(3);
	var runner = __webpack_require__(2);
	var units = __webpack_require__(5);
	var flag = __webpack_require__(6);

	var tasks = {
		add: function(obj){
			var d = data;
			var flag = d.flag;
			var type = typeof obj;

			// A function
			if (type === 'function' && !d.layer && !flag.isAwait) {
				runner.execFunc(obj);
			}
			else {
				// An object (a set of functions)
				type === 'object' && !obj.isTheLastFunctionMarked && (this.markTheLastFunction(obj));
				this.addToLayer(obj);
				!flag.isAwait && units.do(d.tasks[d.layer].shift());
			}
		},

		addToLayer: function(obj){
			var d = data;
			var layer = d.layer;
			var tasks = d.tasks;

			obj.layer = layer;

			typeof tasks[layer] === 'undefined' && (tasks[layer] = []);
			tasks[layer].push(obj);
		},

		markTheLastFunction: function(task){
			var keys = Object.keys(task);
			var func;

			for (var i = keys.length - 1; i >= 0; i --) {
				func = task[keys[i]];
				if (typeof func === 'function') {
					break;
				}
			}

			func.isTheLastFunc = true;
			task.isTheLastFunctionMarked = true;
		},

		clearTheRemainingTasks: function(){
			var d = data;
			var maxLayer = d.maxLayer;
			var arrTasks;
			var lay;

			// clear the remaining functions in this tasks
			for (lay = maxLayer; lay >= 0; lay --) {
				d.units[lay] && (d.units[lay].length = 0);
			}

			// clear the sub tasks in this tasks
			for (lay = maxLayer; lay > 0; lay --) {
				d.tasks[lay] && (d.tasks[lay].length = 0);
			}

			// clear the remaining tasks in this stream
			arrTasks = d.tasks[0];
			while (arrTasks && arrTasks.length) {
				if (arrTasks[0].isStreamBegin) {
					break;
				}
				arrTasks.shift();
			}
		}
	};

	module.exports.__proto__ = tasks;
}),

(function(module, exports, __webpack_require__) {

	var data = __webpack_require__(3);
	var runner = __webpack_require__(2);

	var Tas;
	var currentTask = {};

	var units = {
		init: function(Tas_){
			Tas = Tas_;
		},

		do: function(task){
			this.add(task);

			var queue = data.units[task.layer];
			queue && queue.length && runner.exec(queue);
		},

		add: function(task){
			var d = data;
			var layer = task.layer || 0;

			currentTask.layer = layer;
			currentTask.root = task;

			typeof d.units[layer] === 'undefined' && (d.units[layer] = []);

			var arr = d.units[layer];
			var isTreeEnabled = data.extensions.isTreeEnabled;
			var isInForEach = data.extensions.isInForEach;

			isTreeEnabled && isInForEach && Tas.tree.nested.add();
			isTreeEnabled && !isInForEach && Tas.tree.nested.createFnForBegin(arr);

			var t = task;
			if (typeof task === 'function') {
				var o = {};
				o[task.name] = task;
				o.isAwait = task.isAwait;
				t = o;
			}
			this.getAllFunctions(layer, t, t, t.isAwait, arr, 0);

			isTreeEnabled && isInForEach && Tas.tree.nested.sub();
			isTreeEnabled && !isInForEach && Tas.tree.nested.createFnForEnd(arr);
		},

		getAllFunctions: function getAllFunctions(layer, root, obj, isAwait, arr, deep) {
			var key;
			var func;
			var keys = Object.keys(obj);
			var isTreeEnabled = data.extensions.isTreeEnabled;

			for (var i = 0, len = keys.length; i< len; i ++) {
				key = keys[i];
				func = obj[key];

				if (typeof func === 'object') {
					isTreeEnabled && Tas.tree.nested.createFnForAdd(key, arr, deep);
					getAllFunctions(layer, root, func, isAwait, arr, deep + 1);
					isTreeEnabled && Tas.tree.nested.createFnForSub(arr, deep);
				}
				else
				if (typeof func === 'function') {
					func.root = root;
					func.layer = layer;
					func.isAwait = isAwait;
					arr.push(func);

					isTreeEnabled && (func.treeBranch = key);
					isTreeEnabled && (func.treeIndent = Tas.tree.nested.getCount() + deep);
				}
			}
		},

		clearTheRemainingFunctions: function(){
			var d = data;
			var layer = currentTask.layer;
			var root = currentTask.root;
			var functions = d.units[layer];

			for (var i = 0, len = functions.length; i < len; i ++) {

				/* istanbul ignore else */
				if (functions[i] && functions[i].root === root) {
					functions.shift();
				}
			}
		}
	};

	module.exports.__proto__ = units;
}),

(function(module, exports, __webpack_require__) {

	var data = __webpack_require__(3);

	var flag = {
		isAbort: function(){
			return data.flag.isAbort;
		},

		setIsAbort: function(val){
			data.flag.isAbort = val;
		}
	};

	module.exports.__proto__ = flag;
}),

(function(module, exports, __webpack_require__) {

	var data = __webpack_require__(3);

	var pass = {
		save: function(result){
			var len = result.length;
			len === 2 ? this.save2(result[0], result[1]) :
			len === 1 ? this.save1(result[0]) :
			len === 0 ? this.save0() :
			this.saveArray(result);
		},

		save0: function(){
			var d = data;
			d.pass[0] = undefined;
			d.pass[1] = undefined;
			d.pass.isHasArgs = false;
		},

		save1: function(data_){
			var d = data;
			d.pass[0] = data_;
			d.pass[1] = undefined;
			d.pass.isHasArgs = true;
		},

		save2: function(a0, a1){
			var d = data;
			d.pass[0] = a0;
			d.pass[1] = a1;
			d.pass.isHasArgs = true;
		},

		saveArray: function(arr){
			var d = data;
			d.pass = arr;
			d.pass.isHasArgs = true;
		},

		reset: function(){
			data.pass.length = 0;
			data.pass.isHasArgs = false;
		}
	};

	module.exports.__proto__ = pass;
}),

(function(module, exports, __webpack_require__) {

	var data = __webpack_require__(3);
	var tasks = __webpack_require__(4);
	var pass = __webpack_require__(7);
	var runner = __webpack_require__(2);
	var flag = __webpack_require__(6);
	var tree = __webpack_require__(9);

	var abort = {
		do: function(msg){
			msg && /* istanbul ignore next */ console.log(msg);

			tasks.clearTheRemainingTasks();
			pass.reset();
			runner.next();

			// Set the flag isAbort for subsequent tasks.
			// Otherwise the subsequent tasks will be executed.
			// When the next "begin" tasks started, it will be restore to false.
			flag.setIsAbort(true);

			// Reset log tree if it is enabled.
			data.extensions.isTreeEnabled && tree.reset();
		}
	};

	module.exports.__proto__ = abort;
}),

(function(module, exports, __webpack_require__) {

	var Tas;
	var data = __webpack_require__(3);
	var units = __webpack_require__(5);

	var nested = __webpack_require__(10);
	var forEach = __webpack_require__(11);
	var logArray = __webpack_require__(14);
	var indent = __webpack_require__(12);
	var util = __webpack_require__(13);

	var tree = {
		init: function (Tas_){
			Tas = Tas_;
			forEach.saveTree(this);

			this.logArray = logArray;
			this.nested = nested;
			this.forEach = forEach;

			Tas.tree = this;
			Tas.enableTree = this.enable;
			Tas.disableTree = this.disable;
			Tas.isTreeEnabled = this.isTreeEnabled;
		},

		enable: function(){
			data.extensions.isTreeEnabled = true;
		},

		disable: function(){
			data.extensions.isTreeEnabled = false;
		},

		isTreeEnabled: /* istanbul ignore next*/ function(){
			return data.extensions.isTreeEnabled;
		},

		print: function(func, args){
			var funcName = func.__isIgnore ? func.__label : (func.treeBranch || func.name || '<anonymous>');
			if (!funcName) return;

			if (args) {
				var str = '';
				var maxLen = 200; // 2 lines in terminal of mac os

				args.forEach(function(arg){
					typeof arg !== 'undefined' && (str += JSON.stringify(arg) + ', ');
				});

				str = str.replace(/, $/, '');
				str.length > maxLen && (str = str.substr(0, maxLen) + '...');

				funcName += ' \t// ' + str;
			}

			this.printWithIndent(func, funcName);
		},

		printWithIndent: function(func, funcName){
			typeof func.treeIndent !== 'undefined' && indent.setIndent(func.treeIndent);
			util.log(indent.getStr(), funcName);
		},

		log: function(){
			var args = Array.prototype.slice.call(arguments);
			var indentStr = indent.getStr(true);

			args.unshift(indentStr);
			util.log.apply(null, args);
		},

		reset: function(){
			indent.reset();
			nested.reset();
		}
	};

	module.exports = tree;
}),

(function(module, exports, __webpack_require__) {

	var data = __webpack_require__(3);

	var nested = {
		count: 0,

		add: function(){
			this.count ++;
		},

		sub: function(){
			this.count --;
		},

		getCount: function(){
			return this.count;
		},

		createFnForBegin: function(arr){
			var me = this;
			var fn = function(){
				me.add();
			};

			fn.__isIgnore = true;
			arr.push(fn);
		},

		createFnForEnd: function(arr){
			var me = this;
			var fn = function(){
				me.sub();
			};

			fn.__isIgnore = true;
			arr.push(fn);
		},

		createFnForAdd: function(fnName, arr, deep){
			var me = this;
			var fn = function(){
				me.add();
			};

			fn.treeIndent = this.getCount() + deep;
			fn.__isIgnore = true;
			fn.__label = fnName;
			arr.push(fn);
		},

		createFnForSub: function(arr, deep){
			var me = this;
			var fn = function(){
				!data.flag.isAwait && me.sub();
			};

			fn.treeIndent = this.getCount() + deep;
			fn.__isIgnore = true;
			arr.push(fn);
		},

		reset: function(){
			this.count = 0;
		}
	};

	module.exports.__proto__ = nested;
}),

(function(module, exports, __webpack_require__) {

	var data = __webpack_require__(3);
	var nested = __webpack_require__(10);
	var indent = __webpack_require__(12);
	var tree;

	var forEach = {
		loopTimes: 0,

		pack: function(task){
			var func = task['init'];

			// on begin
			task['init'] = function(data, index){
				forEach.onBegin();
				func(data, index);
			};

			// on end
			// for printing a cut line at end of the forEach
			task['----'] = function(){
				forEach.onEnd();
			};

			task['----'].__ignore = true;
		},

		onBegin: function(){
			indent.backup();
			nested.add();

			data.extensions.isInForEach = true;
		},

		onEnd: function(){
			this.loopTimes = 0;

			indent.restore();
			indent.sub(); // the indent is increased 1 on begin, so here we should decrease 1.
			nested.sub();
			data.extensions.isInForEach = false;
		},

		setLoopTimes: function(val){
			this.loopTimes = val;
		},

		insertSerialNo: function(str){
			return data.extensions.isInForEach ? (str += ' ' + (this.loopTimes + 1) + ':') : str;
		},

		saveTree: function(tree_){
			tree = tree_;
		}
	};

	module.exports.__proto__ = forEach;
}),

(function(module, exports, __webpack_require__) {

	var forEach = __webpack_require__(11);
	var nested = __webpack_require__(10);
	var util = __webpack_require__(13);

	var lastTreeIndent;
	var indent = {
		lastTreeIndent: 0,

		setIndent: function(val){
			this.lastTreeIndent = val;
		},

		sub: function(){
			this.lastTreeIndent --;
		},

		getStr: function(isForLog){
			var level = this.lastTreeIndent + 1 + (isForLog ? 1 : 0);
			var indentStr = util.repeat(' ', (level - 1) * 4);
			var prefix = ('  ' + level).substr(-2) + '|';
			var str = prefix + indentStr;

			return isForLog ? str : forEach.insertSerialNo(str);
		},

		backup: function(){
			lastTreeIndent = this.lastTreeIndent;
		},

		restore: function(){
			this.lastTreeIndent = lastTreeIndent;
		},

		reset: function(){
			this.lastTreeIndent = 0;
		}
	};

	module.exports.__proto__ = indent;
}),

(function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {

	var logArray = __webpack_require__(14);

	var util = {
		log: function(){
			var args = Array.prototype.slice.call(arguments);

			/* istanbul ignore else */
			if (logArray.isSaveToArr) {
				logArray.save(args[0] + ' ' + args[1]);
			}
			else {
				var g = typeof global === 'object' ? global : typeof window === 'object' ? window : {};
				!g.isDisabledLog && console.log.apply(console, args);
			}
		},

		repeat: function (str, times) {
			return new Array(times + 1).join(str);
		}
	};

	module.exports.__proto__ = util;

	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

}),

(function(module, exports) {

	var logArray = {
		data: [],
		isSaveToArr: false,

		begin: function(){
			this.isSaveToArr = true;
			this.data.length = 0;
		},

		save: function(str){
			this.data.push(str);
		},

		getStr: function(){
			return this.data.join('\n');
		}
	};

	module.exports.__proto__ = logArray;
}),

(function(module, exports, __webpack_require__) {

	var units = __webpack_require__(5);

	var break_ = {
		do: function(){
			units.clearTheRemainingFunctions();
		}
	};

	module.exports.__proto__ = break_;
}),

(function(module, exports, __webpack_require__) {

	var flag = __webpack_require__(6);

	var begin = {
		f: false,

		do: function(obj){
			this.f = false;
			obj.isStreamBegin = true;

			// Restore flag isAbort to default value (false).
			flag.setIsAbort(false);

			return obj;
		},

		is: function(){
			return this.f;
		},

		set: function(){
			this.f = true;
		}
	};

	module.exports = begin;
}),

(function(module, exports, __webpack_require__) {

	var Tas;
	var data = __webpack_require__(3);
	var runner = __webpack_require__(2);
	var tasks = __webpack_require__(4);
	var units = __webpack_require__(5);
	var pass = __webpack_require__(7);

	var elements;
	var task;
	var index = 0;
	var tree;

	var forEach = {
		init: function(Tas_){
			Tas = Tas_;
			runner.saveForEach(this);

			Tas.forEach = this.forEach;
			Tas.continue = this.continue;
			Tas.breakForEach = this.breakForEach;

			tree = Tas.tree;
		},

		forEach: function(task){
			task.isForEach = true;

			data.extensions.isTreeEnabled && tree.forEach.pack(task);
			tasks.markTheLastFunction(task);
			data.flag.isAwait ? tasks.add(task) : forEach.exec(task);
		},

		exec: function(task_){
			elements = data.pass[0].slice();
			task = task_;
			index = 0;

			data.extensions.isTreeEnabled && tree.printWithIndent({}, 'forEach');

			forEach.loop();
		},

		loop: function(){
			if (!elements.length) return;

			var d = data;
			var flag = d.flag;

			var isTreeEnabled = data.extensions.isTreeEnabled;
			data.extensions.isInForEach = true;

			while(!flag.isAwait && elements.length) {
				d.layer ++;

				isTreeEnabled && tree.forEach.setLoopTimes(index);
				pass.save2(elements.shift(), index ++);
				tasks.add(task);

				d.layer --;
			}

			!elements.length && forEach.end();
		},

		continue: function(){
			units.clearTheRemainingFunctions();
			forEach.loop();
		},

		breakForEach: function(){
			units.clearTheRemainingFunctions();
			elements.length = 0;
			forEach.end();
		},

		end: function(){
			var fn = function(){
				data.extensions.isInForEach = false;
			};

			fn.__isIgnore = true;
			tasks.add(fn);
		}
	};

	module.exports = forEach;
})


]);}));